from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Directory, Boolean, String

Glam2_V0_1_0 = CommandToolBuilder(tool="glam2", base_command=["glam2"], inputs=[ToolInput(tag="in_output_directory_clobber", input_type=Directory(optional=True), prefix="-o", doc=InputDocumentation(doc=": output directory; will not clobber existing files")), ToolInput(tag="in_output_directory_glamout", input_type=Directory(optional=True), prefix="-O", doc=InputDocumentation(doc=": output directory (glam2_out); allow clobbering")), ToolInput(tag="in_number_alignment_runs", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc=": number of alignment runs (10)")), ToolInput(tag="in_end_run_many", input_type=Boolean(optional=True), prefix="-n", doc=InputDocumentation(doc=": end each run after this many iterations without improvement (10000)")), ToolInput(tag="in_examine_strands_forward", input_type=Boolean(optional=True), prefix="-2", doc=InputDocumentation(doc=": examine both strands - forward and reverse complement")), ToolInput(tag="in_minimum_number_sequences", input_type=Boolean(optional=True), prefix="-z", doc=InputDocumentation(doc=": minimum number of sequences in the alignment (2)")), ToolInput(tag="in_minimum_number_aligned", input_type=Boolean(optional=True), prefix="-a", doc=InputDocumentation(doc=": minimum number of aligned columns (2)")), ToolInput(tag="in_maximum_number_aligned", input_type=Boolean(optional=True), prefix="-b", doc=InputDocumentation(doc=": maximum number of aligned columns (50)")), ToolInput(tag="in_initial_number_aligned", input_type=Boolean(optional=True), prefix="-w", doc=InputDocumentation(doc=": initial number of aligned columns (20)")), ToolInput(tag="in_dirichlet_mixture_file", input_type=Boolean(optional=True), prefix="-d", doc=InputDocumentation(doc=": Dirichlet mixture file")), ToolInput(tag="in__deletion_pseudocount", input_type=Boolean(optional=True), prefix="-D", doc=InputDocumentation(doc=": deletion pseudocount (0.1)")), ToolInput(tag="in__nodeletion_pseudocount", input_type=Boolean(optional=True), prefix="-E", doc=InputDocumentation(doc=": no-deletion pseudocount (2.0)")), ToolInput(tag="in__insertion_pseudocount", input_type=Boolean(optional=True), prefix="-I", doc=InputDocumentation(doc=": insertion pseudocount (0.02)")), ToolInput(tag="in__noinsertion_pseudocount", input_type=Boolean(optional=True), prefix="-J", doc=InputDocumentation(doc=": no-insertion pseudocount (1.0)")), ToolInput(tag="in_weight_generic_e", input_type=Boolean(optional=True), prefix="-q", doc=InputDocumentation(doc=": weight for generic versus sequence-set-specific residue abundances (1e+99)")), ToolInput(tag="in__initial_temperature", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc=": initial temperature (1.2)")), ToolInput(tag="in_cooling_factor_n", input_type=Boolean(optional=True), prefix="-c", doc=InputDocumentation(doc=": cooling factor per n iterations (1.44)")), ToolInput(tag="in_temperature_lower_bound", input_type=Boolean(optional=True), prefix="-u", doc=InputDocumentation(doc=": temperature lower bound (0.1)")), ToolInput(tag="in_print_progress_information", input_type=Boolean(optional=True), prefix="-p", doc=InputDocumentation(doc=": print progress information at each iteration")), ToolInput(tag="in_columnsampling_moves_sitesampling", input_type=Boolean(optional=True), prefix="-m", doc=InputDocumentation(doc=": column-sampling moves per site-sampling move (1.0)")), ToolInput(tag="in_site_sampling_algorithm", input_type=Boolean(optional=True), prefix="-x", doc=InputDocumentation(doc=": site sampling algorithm: 0=FAST 1=SLOW 2=FFT (0)")), ToolInput(tag="in_seed_pseudorandom_numbers", input_type=Boolean(optional=True), prefix="-s", doc=InputDocumentation(doc=": seed for pseudo-random numbers (1)")), ToolInput(tag="in__run_quietly", input_type=Boolean(optional=True), prefix="-Q", doc=InputDocumentation(doc=": run quietly")), ToolInput(tag="in_print_version_exit", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc=": print version and exit (also accepts --version)")), ToolInput(tag="in_embed_file_contents", input_type=Boolean(optional=True), prefix="-M", doc=InputDocumentation(doc=":  embed sequence file contents as hidden field in HTML")), ToolInput(tag="in_make_email_address", input_type=String(optional=True), prefix="-A", doc=InputDocumentation(doc=":  make email address a hidden field in HTML")), ToolInput(tag="in_make_description_field", input_type=String(optional=True), prefix="-X", doc=InputDocumentation(doc=":  make description a hidden field in HTML")), ToolInput(tag="in_alphabet", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_my_seqs_dot_fa", input_type=String(), position=1, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output_directory_clobber", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_output_directory_clobber", type_hint=File()), doc=OutputDocumentation(doc=": output directory; will not clobber existing files")), ToolOutput(tag="out_output_directory_glamout", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_output_directory_glamout", type_hint=File()), doc=OutputDocumentation(doc=": output directory (glam2_out); allow clobbering"))], container="quay.io/biocontainers/meme:5.3.0--py38pl526hc1f1133_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Glam2_V0_1_0().translate("wdl")

